/*
 * Copyright (c) 2004 X-Way Rights BV
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*!\file DHParameterSpec.h
 * \ingroup CXX_CRYPTO_SPEC_m
 */

#ifndef _CLASS_BEE_CRYPTO_SPEC_DHPARAMETERSPEC_H
#define _CLASS_BEE_CRYPTO_SPEC_DHPARAMETERSPEC_H

#ifdef __cplusplus

#include "beecrypt/c++/crypto/interfaces/DHParams.h"
using beecrypt::crypto::interfaces::DHParams;
#include "beecrypt/c++/security/spec/AlgorithmParameterSpec.h"
using beecrypt::security::spec::AlgorithmParameterSpec;

namespace beecrypt {
	namespace crypto {
		namespace spec {
			/*!\ingroup CXX_CRYPTO_SPEC_m
			 */
			class BEECRYPTCXXAPI DHParameterSpec : public Object, public virtual AlgorithmParameterSpec, public virtual DHParams
			{
			private:
				BigInteger _p;
				BigInteger _g;
				int  _l;

			public:
				DHParameterSpec(const DHParams&);
				DHParameterSpec(const DHParameterSpec&);
				DHParameterSpec(const BigInteger& p, const BigInteger& g);
				DHParameterSpec(const BigInteger& p, const BigInteger& g, int l);
				virtual ~DHParameterSpec() {}

				virtual bool equals(const Object* obj) const throw ();

				const BigInteger& getP() const throw ();
				const BigInteger& getG() const throw ();
				int getL() const throw ();
			};
		}
	}
}

#endif

#endif
